
	/**********************************************************************************
	  
	attiny2313    12     SPIN = SUT1 = 0  "v"  PoniProg
		
	**************************************************************************************/
     
	#include <avr/io.h>
	#include <stdlib.h>       //  -   
    #include"nec_helper.h"
	#define F_CPU 12000000UL
	 
	#define BUTTON  PB3            //   
     
	unsigned char gencount=1;    //   
	unsigned int ram=0;     	 //  
	
    // ------------------ -    ---------------------------
	 
	void tim_dat(unsigned char tt)
	{
	for(unsigned char i=0; i < tt; i++)
		{ 
		if(bit_is_clear(PINB,BUTTON)) 
			{
			if(gencount < 4)
				{
				  gencount++;
				  ind_led(2); //   
				  _delay_ms(900);
				}
			}
		else  _delay_ms(100);
		}
	}
	   
    //===========================   ========================================
	 
	int main(void)  //Hauptprogramm
	{
  	unsigned char pam=0;       	 //    
    unsigned char devic=0; 		 //   
	unsigned char aa,bb,cc,dd;	 //  
	
      DDRB =0x04; PORTB = 0xFB; 
	  DDRD =0x3E; PORTD = 0x40;
	 
	  ACSR &= ~_BV(ACIE); //     
	  ACSR |= _BV(ACD);  //    
	 
	  ind_led(3);   //   
	  
	  srand(24);    //    
	 	
	while(1) 
		{ 
		do   // ,   =1
			{
			if((bit_is_set(PINB,BUTTON))&&(ram < 300))  //        300
				{
				  PORTD |= _BV(IND);                      //   
				  _delay_ms(200);
				  PORTD &= ~_BV(IND);
				  _delay_ms(800);
				  
				  ram++;                            //     
				}
			else                                    //         
				{
				if(gencount < 4)
					{
					  ram=0;        //  
					  gencount++;   //   
					  ind_led(2); //   
					  _delay_ms(900);
					}
				}	
			}
		while(gencount==1);
			
		  PORTD &= ~_BV(IND);       //   
			
		if(gencount==2)   //    
			{
			  ind_led(2); //   
			  pam=48;     // 48 * 2.5s = 240s          
			  
			while(gencount==2)
				{
				  aa=colour_dat(rand() % 12);   //    
				  bb=colour_dat(rand() % 12);
				  cc=colour_dat(rand() % 12);
				  dd=colour_dat(rand() % 12);
				  
				  TransmitBloc(aa,bb,cc,dd,5);  //     
				 
				  tim_dat(50);   
				if(--pam == 0) gencount=3;   //    
				}
			}    // : 240s
			 
		//--------------------------------------------------------------------------------------------------------------
		 
		if(gencount==3)   //   4-  R0-G0-B0-B4
			{
			  ind_led(3); //   
			  pam=40;      // 40 * 6s = 240       
			  
			while(gencount==3)
				{
				if(devic==0)
					{
					  TransmitBloc(0x20,0xA0,0x60,0x68,5);
					}
				if(devic==1)
					{  
					  TransmitBloc(0x68,0x20,0xA0,0x60,5);
					}
				if(devic==2)
					{  
					  TransmitBloc(0x60,0x68,0x20,0xA0,5);
					}
				if(devic==3)
					{  
					  TransmitBloc(0xA0,0x60,0x68,0x20,5);
					}  
				  tim_dat(60);  //     
				  
				if(++devic > 3)devic =0;
				  
				if(--pam == 0)   gencount=4;  //    
				}
			}         // : 240s
			 
		//--------------------------------------------------------------------------------------------------------------
		  
		if(gencount==4)   //   4-  R0-G0-B0-B4   4-    
			{
			  ind_led(4); //   
			  
			while(gencount==4)   //    4-      
				{
				if(devic==0)
					{
					  TransmitBloc(0x20,0x20,0x20,0x20,5);
					}
				if(devic==1)
					{  
					  TransmitBloc(0xA0,0xA0,0xA0,0xA0,5);
					}
				if(devic==2)
					{  
					  TransmitBloc(0x60,0x60,0x60,0x60,5);
					}
				if(devic==3)
					{  
					  TransmitBloc(0x68,0x68,0x68,0x68,5);
					}  
				  tim_dat(50);  //     
				  
				if(++devic > 3)devic =0; //    0  3  
				}
			}	
		}
	}	               //   1682 bytes ( 82.1 % )	



